#! /usr/bin/env python

# Reverse a CRP file [segment]

# Author: Frank Paehlke
# $Id: crpreverse.py,v 1.3 2004/09/29 19:17:12 frank Exp $

import sys
from optparse import OptionParser
import string
import crputils_version

def main():
    global options
    # parse command line arguments
    parser = OptionParser(usage="%prog [options] [infile [outfile]]",
                          version=crputils_version.version)
    parser.add_option ("-v", "--verbose", action="store_true",
                       dest="verbose", default=False,
                       help="turn on debugging output")
    (options, args) = parser.parse_args()

    ifilename = "-"
    ofilename = "-"
    if len(args) >= 1:
        ifilename = args[0]
        if len(args) >= 2:
            ofilename = args[1]
            if len(args) > 2:
                print >> sys.stderr, "Ignoring extra argument(s):", args[2:]
    if options.verbose:
        print >> sys.stderr, "Input file:", ifilename
        print >> sys.stderr, "Output file:", ofilename

    # do the actual work
    if ifilename == '-':
        ifile = sys.stdin
    else:
        ifile = open(ifilename)
    if ofilename == '-':
        ofile = sys.stdout
    else:
        ofile = open(ofilename, "w")
    reverseFile(ifile, ofile)
    if ifile != sys.stdin: ifile.close()
    if ofile != sys.stdout: ofile.close()

# do the actual concatenation, adding offset [km/100] to each distance value
# return last distance value (to be used as offset for next invocation)

def reverseFile (ifile,ofile):
    
    # skip header lines
    line = ifile.readline()
    if (line[0:3] == "HRM"):
        line = ifile.readline()
        line = ifile.readline()
    # read input file line by line into buffer lines[]
    lines = []
    while 1:
        if not line or line[0:3] == "***": break
        # split the line into fields, get distance
        fields = string.split(line, '\t')
        dist = int(fields[2])
        # add all fields to buffer
        lines.append(fields)
        # read next line
        line = ifile.readline()
    # now we have determined the end distance
    endDist = dist
    if options.verbose:
        print >> sys.stderr, "number of lines:", len(lines)
        print >> sys.stderr, "end distance:", round(endDist*0.01,2), "km"
    # output lines in reverse order
    lines.reverse()
    for fields in lines:
        # output line
        dist = int(fields[2])
        fields[2] = `endDist - dist`
        line = string.join (fields, '\t')
        ofile.write(line)

main()
